%define soname 0

Name:           mpg123
Version:        1.13.4
Release:        1.pm.1.2

License:        LGPL 2.1
Summary:        Realtime Player for MPEG Audio Layer 1, 2, and 3 Files
Url:            http://mpg123.org/
Group:          Productivity/Multimedia/Sound/Players

Source:         http://mpg123.org/download/%{name}-%{version}.tar.bz2
Source99:       mpg123-rpmlintrc

Patch1:         mpg123-remove_reldir_fallback.patch

Requires:       libmpg123-%{soname} = %{version}

BuildRoot:      %{_tmppath}/%{name}-%{version}-build

BuildRequires:  SDL-devel
BuildRequires:  alsa-devel
BuildRequires:  arts-devel
BuildRequires:  esound-devel
BuildRequires:  gcc
BuildRequires:  glibc-devel
BuildRequires:  libao-devel
BuildRequires:  libaudio-devel
BuildRequires:  libjack-devel
BuildRequires:  libpulse-devel
BuildRequires:  libtool
BuildRequires:  make
BuildRequires:  pkg-config
BuildRequires:  portaudio-devel
%if 0%{?suse_version} > 1110
BuildRequires:  openal-soft-devel
%else
BuildRequires:  openal-devel
%endif

%description
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

%package -n lib%{name}-devel
License:        LGPL 2.1
Summary:        Include Files and Libraries mandatory for Development
Group:          Development/Libraries/C and C++
Requires:       glibc-devel
Requires:       lib%{name}-%{soname} = %{version}

%description -n lib%{name}-devel
This package contains the files needed to compile programs that use
the mpg123 library.

%package -n lib%{name}-%{soname}
Summary:        Realtime Player Library for MPEG Audio Layer 1, 2, and 3 Files
Group:          System/Libraries

%description -n lib%{name}-%{soname}
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

%package arts
Summary:        Artsd KDE Sound System Daemon Support for %{name}
Group:          Productivity/Multimedia/Sound/Players

%description arts
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This package contains the plugin for artsd (the KDE sound system daemon)
output support.

%package esound
Summary:        Esound GNOME Sound System Daemon Support for %{name}
Group:          Productivity/Multimedia/Sound/Players

%description esound
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This package contains the plugin for esound (the GNOME sound system daemon)
output support.

%package pulse
Summary:        Pulseaudio Support for %{name}
Group:          Productivity/Multimedia/Sound/Players

%description pulse
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This package contains the plugin for Pulseaudio output support.

%package jack
Summary:        Jack Support for %{name}
Group:          Productivity/Multimedia/Sound/Players

%description jack
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This package contains the plugin for JACK output support.

%package portaudio
Summary:        Portaudio Support for %{name}
Group:          Productivity/Multimedia/Sound/Players

%description portaudio
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This package contains the plugin for Portaudio output support.

%package sdl
Summary:        SDL Support for %{name}
Group:          Productivity/Multimedia/Sound/Players

%description sdl
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This package contains the plugin for SDL output support.

%package nas
Summary:        NAS Support for %{name}
Group:          Productivity/Multimedia/Sound/Players

%description nas
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This package contains the plugin for NAS (Network Audio System) output
support.

%package all
Summary:        Support for all output plugins in %{name}
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name}-jack = %{version}
Requires:       %{name}-portaudio = %{version}
Requires:       %{name}-pulse = %{version}
Requires:       %{name}-sdl = %{version}

%description all
Mpg123 is a fast, free and portable MPEG audio player for Unix. It supports
MPEG 1.0/2.0/2.5 layers 1, 2, and 3, with CD quality playback even on
relatively slow CPUs.

This is an empty package that installs (requires) all output plugins for
%{name} that are kept in separate subpackages, except
- %{name}-esd (esound support)
- %{name}-arts (aRTs sound daemon support)
- %{name}-nas (NAS (Network Audio Server) support)
which have to be installed separately.

Install this package if you want to make sure you have all supported
output plugins (except esd, arts and nas).

%prep
%setup -q
%patch1

%build
%configure \
%ifarch i586
    --with-cpu=i586_dither      \
%endif
%ifarch i686
    --with-cpu=mmx              \
%endif
%ifarch athlon
    --with-cpu=3dnow            \
%endif
%ifarch x86_64
    --with-cpu=x86-64_dither    \
%endif
    --with-default-audio=alsa   \
    --enable-modules=yes \
    --enable-ipv6=yes \
    --enable-network=yes \
    --enable-fifo=yes \
    --enable-gapless=yes \
    --with-optimization=0 \
    --with-module-suffix=.so

make %{?_smp_mflags}

%install
%makeinstall

rm -f %{buildroot}%{_libdir}/lib%{name}.la
rm -f %{buildroot}%{_libdir}/%{name}/*.la

rm -f doc/README.WIN32
rm -f doc/Makefile*

install -d "%{buildroot}%{_docdir}/%{name}"
>rpmdocfiles.lst
pushd doc
for f in *.txt; do
    install -m0644 "$f" "%{buildroot}%{_docdir}/%{name}/$f"
    echo "%doc %{_docdir}/%{name}/$f" >>../rpmdocfiles.lst
done
/bin/ls -1d *|grep -E '^[[:upper:]]+.*' | while read f; do
    install -m0644 "$f" "%{buildroot}%{_docdir}/%{name}/$f"
    echo "%doc %{_docdir}/%{name}/$f" >>../rpmdocfiles.lst
done
popd #doc
cp -a doc/examples "%{buildroot}%{_docdir}/%{name}/"

cat >README-all <<EOF
This package is just a placeholder to install all available
%{name} plugins.
EOF

%post   -n lib%{name}-%{soname} -p /sbin/ldconfig
%postun -n lib%{name}-%{soname} -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%files -f rpmdocfiles.lst
%defattr(-,root,root)
%doc %dir %{_docdir}/%{name}
%{_bindir}/mpg123
%doc %{_mandir}/man1/mpg123.1%{ext_man}
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/output_alsa.so
%{_libdir}/%{name}/output_dummy.so
%{_libdir}/%{name}/output_openal.so
%{_libdir}/%{name}/output_oss.so

%files -n lib%{name}-devel
%defattr(-,root,root)
%doc %{_docdir}/%{name}/examples
%{_includedir}/%{name}.h
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/lib%{name}.pc

%files -n lib%{name}-%{soname}
%defattr(0644,root,root)
%{_libdir}/lib%{name}.so.%{soname}
%{_libdir}/lib%{name}.so.%{soname}.*.*

%files arts
%defattr(-,root,root)
%{_libdir}/%{name}/output_arts.so

%files esound
%defattr(-,root,root)
%{_libdir}/%{name}/output_esd.so

%files pulse
%defattr(-,root,root)
%{_libdir}/%{name}/output_pulse.so

%files jack
%defattr(-,root,root)
%{_libdir}/%{name}/output_jack.so

%files portaudio
%defattr(-,root,root)
%{_libdir}/%{name}/output_portaudio.so

%files sdl
%defattr(-,root,root)
%{_libdir}/%{name}/output_sdl.so

%files nas
%defattr(-,root,root)
%{_libdir}/%{name}/output_nas.so

%files all
%defattr(-,root,root)
%doc README-all

%changelog
* Fri Sep  9 2011 detlef@links2linux.de
- update to 1.13.4:
  * Fix bogus error on resync with big offsets (hits systems that have bigger
    off_t than int), bug 3393801.
  * Fix windows binary package build script again with plugdir.
* Sat Apr 23 2011 detlef@links2linux.de
- update to 1.13.3:
  * Fix an endless loop on bad headers, bug 3267863.
  * Prevent compiler warnings about unused variables with gcc 4.6 .
  * Fix return value handling of getaddrinfo(), bug 3288333.
  * Make decwin size computation work for OPT_ARM and sizeof(long) != 4
    (bug 3288360).
* Sat Mar  5 2011 reddwarf@opensuse.org
- remove .la files
- run spec-cleaner
- remove pre-11.1 conditionals
- the audio output plugins are plugins for the command line, not
  for the library, package according
* Wed Feb 23 2011 pascal.bleser@opensuse.org
- update to 1.13.2:
  * fixes a long-standing bug with unexpected early calls of mpg123_decoder()
  * fixes a regression with pitch changes and the generic control interface
    when no track is loaded
* Thu Jan  6 2011 pascal.bleser@opensuse.org
- update to 1.13.1:
  * fixes a stupid regression that broke MPG123_FORCE_FLOAT and
    MPG123_FORCE_8BIT (--float and --8bit command line switches), caused by the
    introduction of 24-bit format support
  * the private/extension header bit is now ignored in the parser's stream
    checking
* Mon Oct 18 2010 detlef@links2linux.de
- update to 1.13.0:
  * libmpg123 API version 29 (mpg123_encsize(), MPG123_SKIP_ID3V2,
    mpg123_strlen(), 24 bit output, ARM decoder)
  * New optimization: ARM NEON (Cortex A series) -- kudos to Taihei, again!
  * Added 24 bit integer output (truncation of 32 bit integer)
  * Cleanup of symbols for the static library: Only have global symbols that
    are actually needed, prefix them with INT123_ to avoid conflicts.
  * Added --streamdump to get a copy of the data libmpg123 used.
  * Added --icy-interval and tweaked libmpg123 to make playback of ICY stream
    dumps possible.
  * Added possibility to set module file suffix at build -- to be able to
    avoid .la files for plugins.
  * Removed compiler directives for alignment and disable associated tests.
    The tests don't work on a wide range of compilers anyway, and newer gccs
    do have force_align_arg_pointer to fix bad stacks.
  * There is no ChangeLog file anymore... it was autogenerated from subversion
    log anyway, so look there if interested.
* Thu Oct  7 2010 pascal@links2linux.de
- update to 1.12.5:
  * fixes a buffer overflow in the mpg123 frontend application related to the
    printing of ID3 tags with embedded null characters in non-UTF-8 environments
* Sat Sep 18 2010 detlef@links2linux.de
- update to 1.12.4:
  * Fix formatting of meta data printout in UTF-8 (string length computing).
    As a collorary, ID3v1 data is reduced to ASCII in UTF-8 environment, as we
    do never know what specific encoding that has.
* Sun Jul 11 2010 detlef@links2linux.de
- update to 1.12.3:
  * Fix a long-standing bug that subtly broke http streaming with ICY meta data
    when reading a bit more quickly
* Mon Jun 21 2010 pascal@links2linux.de
- update to 1.12.2:
  * fix for memory corruption on systems that hand out memory in
    the upper half of the address space
  * several other improvements in portability and binary
    compatibility with respect to small/large file setups
* Sun May  9 2010 herbert@links2linux.de
- add baselib.conf
* Wed Mar 31 2010 pascal@links2linux.de
- update to 1.12.0:
  * reverses the changes made in the previous release, 1.11.0
  * libmpg123_64.so it introduced on largefile-sensitive systems is gone now
  * libmpg123 provides a dual mode interface similar to the libc
  * this version marks the first stable ABI for largefile-sensitive systems
    since mpg123 1.4.x
  * as a side effect of dual mode hacking, replacement I/O using
    client-provided handles (void pointer) has been added to the API
  * the introduction of AI_ADDRCONFIG has been made conditional based on the
    actual availability of that flag on a system
* Sun Mar 21 2010 pascal@links2linux.de
- update to 1.11.0:
  * improvements to hybrid setups of small and large file support
  * IPv6 behavior was improved
  * a potential ICY reading issue was resolved
  * assembler code was cleaned up
* Sat Feb 27 2010 detlef@links2linux.de
- update to 1.10.1:
  * Help multilib setups that boldly assume that headers are invariant by
    removing the consistency check in mpg123.h and instead just adding a
    suffix to relevant functions when _FILE_OFFSET_BITS is defined. Invalid
    setups will now fail at the linking stage instead of the preprocessing
    stage. That should cover bug 2934488.
  * Fixes for gapless decoding:
    o Correctly skip padding larger than one MPEG frame (strange, but occurs).
    o Bug 2950218 (proper gapless cuts for seeking near the end).
  * Make sure the search for the first header aborts after 64K of one-byte
    reads, as always intended (bug 2951334).
    Certain files (or even random data) were able to fool mpg123 sufficiently
    enough that it basically reads through the whole file in 1-byte steps in
    search for MPEG data. The limit of 64K will very likely be configurable
    in a future mpg123 version.
  * Fix subtle bug with seeking in feeder mode: A seek close to the current position
    (meaning: the needed data offset is already in mpg123's buffer chain)
    resulted in skipped bytes.
  * Improve the feeder mode for handling large amounts of junk at the beginning,
    including proper passing of the request for more data when trying to determine
    free format frame size. This also fixes endless looping as reported in bug 2951334.
  * The parser code still needs overhaul. It is not pretty.
  * Compile fix for OpenAL (with strict compiler).
* Sun Dec  6 2009 pascal.bleser@opensuse.org
- update to 1.10.0:
  * added pitch command to control interface
  * HTTP header field and MIME type parsing now case-insensitive (fixes bug
    2904736); MIME-parsing for non-playlist URLs is done the same way as from
    playlists now; we interpret MIME types only to before a ";" (see bug
    2836904)
  * add experimental framebyframe API
* Fri Nov 20 2009 detlef@links2linux.de
- update to 1.9.2:
  * many bugfixes
* Fri Oct  9 2009 pascal.bleser@opensuse.org
- update to 1.9.1:
  * a set of bugs have been fixed, along with some long- and short-standing
    regressions, namely NtoM CPU creep and parsing of Foobar2000-style RVA info
    in ID3v2 tags
  * new openal output plugin
* Sun Jun 14 2009 pascal.bleser@opensuse.org
- update to 1.8.1:
  * adds the proper integer/fixed point decoding that accidentally had been
    promised for the 1.8.0 release
  * minor bugs and build system problems were fixed
* Thu Jun 11 2009 pascal.bleser@opensuse.org
- update to 1.8.0:
  * major performance improvements (including new SSE code) for x86-64 systems
    (and others)
  * fixes to the correctness of decoding
  * the fixed point decoding (compile-time option) now works properly for layer
    1 and 2
* Mon Apr 27 2009 pascal.bleser@opensuse.org
- update to 1.7.3:
  * a bad-sounding regression with seeking in layer 3 files has been fixed;
    this regression had been introduced in 1.7.0 with the --doublespeed
    revival
* Mon Apr  6 2009 pascal.bleser@opensuse.org
- renamed mpg123-devel to libmpg123-devel, with a Provides:mpg123-devel
  for compatibility with existing spec files
- split out support for pulse, jack, portaudio and sdl into subpackages
- the empty package lib%%%%{name}-%%%%{soname}-all pulls in all subpackages with
  output engine support
- update to 1.7.2:
  * fixes a vulnerability in the ID3v2 code with invalid text encoding values
- changes from 1.7.1:
  * fixes a regression that prevented the RVA changes in the generic control
    interface or from the terminal from resulting in something other than
    silence
- changes from 1.7.0:
  * significant overhaul of the decoder engine to be more flexible at runtime
    and include more output formats
  * float and 32-bit integer output are now standard features of a normal build
  * the --doublespeed functionality is back again after being silently absent
    in the 1.x series
  * support for configuring minimal libmpg123 builds by stripping out certain
    features
* Sun Jan 11 2009 detlef@links2linux.de
- new upstream version <1.6.4>
  * frame fill fix
* Sun Dec 21 2008 detlef@links2linux.de
- new upstream version <1.6.3>
  * Fix sf.net bug #2413608: Make sure a new format does not slip through after
    early close.
  * Include equalizer example file and a piece of wrapper code for MSVC++ in
    the distribution.
  * Do not claim to support unsigned 16 bit encoding (never been the case).
  * Fix default fifo detection, now it actally activates fifo support!
* Tue Nov 11 2008 detlef@links2linux.de
- new upstream version <1.6.2>
  * fixing that typo in configure.ac that prevents IPv6 auto detection
* Mon Nov 10 2008 guru@unixtech.be
- update to 1.6.1:
  * small bugfix for large file offsets in the remote control interface
  * some portability fixes
* Wed Nov  5 2008 guru@unixtech.be
- use %%%%{_libdir}/%%%%{name}-%%%%{soname}/ instead of %%%%{_libdir}/%%%%{name}/ for
  output plugins, to enable side-by-side installation of different
  SONAME versions of the package (they would conflict on the output
  plugins otherwise)
- added patch to remove the falling back on ../lib/mpg123 when loading
  output modules
- splitted out library and codecs, following SUSE Shared Library Policy
  package naming
- added Provides:mpg321
- splitted out arts and esd support because of dependencies and because
  those sound daemons are rarely used nowadays
- update to 1.6.0:
  * decoding improvements were made
  * new commands and API features were added for fast fuzzy seeking (using
    estimates or the Xing VBR TOC)
  * bugs were fixed
  * largefile support
* Sat Aug 30 2008 detlef@links2linux.de
- new upstream version <1.5.1>
* Sat Aug  2 2008 detlef@links2linux.de
- new upstream version <1.5.0>
* Fri May 23 2008 detlef@links2linux.de
- new upstream version <1.4.3>
* Sun Apr 20 2008 detlef@links2linux.de
- new upstream version <1.4.2>
* Sat Apr 19 2008 detlef@links2linux.de
- build all output plugins
- split devel rpm
- mpg123 provides mpg321 now
* Tue Apr  8 2008 detlef@links2linux.de
- new upstream version <1.4.1>
* Mon Apr  7 2008 detlef@links2linux.de
- new upstream version <1.4.0>
* Sun Mar  9 2008 detlef@links2linux.de
- new upstream version <1.3.1>
* Wed Mar  5 2008 detlef@links2linux.de
- new upstream version <1.3.0>
* Thu Feb 21 2008 detlef@links2linux.de
- new upstream version <1.2.1>
* Fri Feb  1 2008 detlef@links2linux.de
- new upstream version <1.2.0>
* Thu Jan 17 2008 detlef@links2linux.de
- new upstream version <1.1.0>
* Fri Dec 28 2007 detlef@links2linux.de
- new upstream version <1.0.1>
* Sun Dec 23 2007 detlef@links2linux.de
- new upstream version <1.0.0>
* Tue Dec 18 2007 detlef@links2linux.de
- new upstream version <1.0rc3>
* Mon Nov  5 2007 detlef@links2linux.de
- new upstream version <0.68>
* Tue Aug  7 2007 detlef@links2linux.de
- new upstream version <0.67>
* Thu Jun  7 2007 detlef@links2linux.de
- new upstream version <0.66>
* Tue Feb 13 2007 detlef@links2linux.de
- new upstream version
* Wed Oct 18 2006 detlef@links2linux.de
- rebuild for packman
* Thu Aug 31 2006 guru@unixtech.be
- new upstream version
* Wed Aug 23 2006 guru@unixtech.be
- changed audio backend to alsa
- new upstream version
* Mon Jul 31 2006 guru@unixtech.be
- new upstream version
* Tue Jul 25 2006 guru@unixtech.be
- new package
